Main : Process {
	var platform, argv;
	var <>recvOSCfunc;
	
		// proof-of-concept: the interpreter can set this variable when executing code in a file
		// should be nil most of the time
	var	<>nowExecutingPath;

	startup {
		var cond;
		// setup the platform first so that class initializers can call platform methods.
		// create the platform, then intialize it so that initPlatform can call methods
		// that depend on thisProcess.platform methods.
		SynthDef.synthDefDir_("Palimpsest.app/Contents/Resources/synthdefs");
		platform = this.platformClass.new;
		platform.initPlatform;
		super.startup;
		// set the 's' interpreter variable to the internal server.
		interpreter.s = Server.internal;
		GUI.fromID( this.platform.defaultGUIScheme );
		GeneralHID.fromID( this.platform.defaultHIDScheme );
		this.platform.startup;
		StartUp.run;
		(
			osx: "Welcome to SuperCollider, type cmd-d for help"
		 ).at(platform.name).postln;
		cond = Condition.new;
		// server windows turned off for stand-alone application
		Server.internal.makeWindow;
//		Server.local.makeWindow;
		interpreter.s.options.numOutputBusChannels_(4).numInputBusChannels_(4).numAudioBusChannels_(256)
			.memSize_(32768 * 8);
		Server.default = interpreter.s;
		interpreter.s.boot;
		// Start the application using internal server
		interpreter.s.waitForBoot({
			
			var palimpsest, win, yval, zval;
//				interpreter.s.nextNodeID;
//				thisProcess.interpreter.executeFile("Palimpsest.app/Contents/Resources/PalimpsestSD.rtf");
		zval = SCWindow.screenBounds;
		yval = thisProcess.interpreter.executeFile("Palimpsest.app/Contents/Resources/Palimpsest.rtf");
		
		win=SCWindow.new("Is this live? Or a recorded test?", 
			Rect(zval.width* 0.35, zval.height * 0.65, zval.width * 0.35, zval.height * 0.15));
		SCButton(win, 
			Rect(win.bounds.width * 0.1, win.bounds.height * 0.1, win.bounds.width * 0.3,
				win.bounds.height * 0.8))
			.states_([
				["A live performance", Color.black, Color(0.3, 0.3, 0.7, 0.3)]])
			.action_({
				win.close;
				win=SCWindow.new("Would you like to save a recording of the performance?",
					Rect(zval.width* 0.35, zval.height * 0.65, zval.width * 0.35, 
						zval.height * 0.15));
				SCButton(win, 
					Rect(win.bounds.width * 0.1, win.bounds.height * 0.1, win.bounds.width * 0.3,
						win.bounds.height * 0.8))
					.states_([
						["Yes, save a copy", Color.black, Color(0.3, 0.3, 0.7, 0.3)]])
					.action_({
						win.close;
						yval.value(false, true, nil);
						});
				SCButton(win, 
					Rect(win.bounds.width * 0.6, win.bounds.height * 0.1, win.bounds.width * 0.3,
						win.bounds.height * 0.8))
					.states_([
						["No, do not save a copy", Color.black, Color(0.3, 0.3, 0.7, 0.3)]])
					.action_({
						win.close;
						yval.value(false, false, nil);
						});
				win.front;
			});
						
		SCButton(win, 
			Rect(win.bounds.width * 0.6, win.bounds.height * 0.1, win.bounds.width * 0.3,
				win.bounds.height * 0.8))
			.states_([
				["A recorded test \n(choose file)", Color.black, Color(0.7, 0.3, 0.3, 0.3)]])
			.action_({
				win.close;
				CocoaDialog.getPaths({arg paths;
					yval.value(true, false, paths[0]);
					}, {
					"You must choose a file to run in practice mode".postln;
					})
				});		
		win.front;
		}, 25);		
	}
	
	shutdown { // at recompile, quit
		Server.quitAll;
		this.platform.shutdown;
		super.shutdown;
	}
	
	run { // called by command-R
	
	}
	
	stop { // called by command-.

		SystemClock.clear;
		AppClock.clear;
		TempoClock.default.clear;
		CmdPeriod.clear;
		
		Server.freeAll; // stop all sounds on local servers
		Server.resumeThreads;
	}
	
	recvOSCmessage { arg time, replyAddr, msg;
		/// added by tboverma on Jul-17-2006
		recvOSCfunc.value(time, replyAddr, msg);
		// this method is called when an OSC message is received.
		OSCresponder.respond(time, replyAddr, msg);
	}

	recvOSCbundle { arg time, replyAddr ... msgs;
		// this method is called when an OSC bundle is received.
		msgs.do({ arg msg; 
			this.recvOSCmessage(time, replyAddr, msg); 
		});
	}
	
	newSCWindow {
		var win, palette;
		win = SCWindow("construction");
		win.front;
		win.toggleEditMode;
	}


	platformClass {
		// override in platform specific extension
		^Platform
	}
	platform {
		^platform ?? { platform = this.platformClass.new }
	}
	argv {
		^argv ?? { argv = this.prArgv }
	}

	showHelpBrowser {
		Help.gui
	}
	
	// PRIVATE
	prArgv {
		_Argv
		^[]
	}
}
